<template>
  <GenericLayout>
    <template #header>
      <Header
        fastplatform-logo
        :title="pageTitle"
      />
    </template>

    <template #page-content>
      <template v-if="isDesktopPlatform">
        <div
          class="page-title"
          v-if="pageTitle"
        >
          {{ pageTitle }}
        </div>
      </template>

      <div
        v-if="loading"
        class="column flex-center"
      >
        <q-spinner-dots
          size="24px"
          color="primary"
        />
      </div>

      <LoadErrorCard
        v-else-if="loadError"
        @retry="onDataLoadRetry"
      />

      <q-card
        :square="!isDesktopPlatform"
        v-else-if="holdings && campaigns"
        class="full-height column"
      >
        <!-- Errors -->
        <template v-if="syncError">
          <q-card-section>
            <SyncFeedback v-if="hasUserForbiddenError">
              <translate>You are not authorized to access the farm data</translate>
              <template #message>
                <span
                  v-translate
                  render-html="true"
                >
                  Check with %{iacsLink} that you have the authorization to access the farm data.</span>
              </template>
            </SyncFeedback>

            <SyncFeedback
              v-else-if="hasUserUnauthenticatedError"
              :icon-color="warning"
            >
              <translate>You session has expired</translate>
              <template #message>
                <span
                  v-translate
                  render-html="true"
                >
                  You must login again with %{iacsName} (%{iacsShortName}).</span>
              </template>
            </SyncFeedback>

            <SyncFeedback v-else-if="hasObjectNotFoundError">
              <translate>There is no farm data corresponding to your username</translate>
              <template #message>
                <span
                  v-translate
                  render-html="true"
                >
                  Check with %{iacsLink} that your username (%{username}) is registered.</span>
              </template>
            </SyncFeedback>

            <SyncFeedback
              v-else-if="hasRemoteError"
            >
              <translate>There was an error when importing your farm data</translate>
              <template #message>
                <span
                  v-translate
                  render-html="true"
                >
                  It looks like %{iacsLink} is not available. Please try again later.
                </span>
              </template>
            </SyncFeedback>

            <SyncFeedback
              v-else-if="hasServiceOrUnexpectedError"
              icon-color="negative"
            >
              <translate>There was an error when importing your farm data</translate>
              <template #message>
                <span
                  v-translate
                  render-html="true"
                >
                  An unexpected error occurred. Please try again later.
                </span>
              </template>
            </SyncFeedback>

            <!-- else do not display anything (it may occur if the user cancels the iacs token refresh) -->
          </q-card-section>
        </template>

        <!-- Result -->
        <template v-else-if="syncResult">
          <q-card-section>
            <SyncFeedback
              v-if="hasSuccessfulResult"
              icon-name="las la-check"
              icon-color="positive"
            >
              <translate>Farms were successfully synchronized</translate>
              <template #message>
                <translate :translate-params="{ farmCount: syncResult.synchronizedHoldingCount }">
                  %{farmCount} farm(s) found:
                </translate>
                <q-list class="q-mt-md">
                  <q-item
                    v-for="holding in holdings"
                    :key="holding.id"
                    class="q-px-none"
                  >
                    <q-item-section side>
                      <q-icon name="las la-minus" />
                    </q-item-section>
                    <q-item-section>
                      <q-item-label>
                        {{ holding.name }}
                      </q-item-label>
                    </q-item-section>
                  </q-item>
                </q-list>
              </template>
            </SyncFeedback>

            <SyncFeedback
              v-else-if="hasEmptyResult"
              icon-color="warning"
            >
              <translate>No farm found</translate>
              <template #message>
                <translate>
                  We could not find any farm for you in the administration database. You can either retry or start with a demo farm.
                </translate>
              </template>
            </SyncFeedback>
          </q-card-section>
        </template>

        <!-- IACS consent -->
        <template v-else>
          <q-card-section class="q-pt-lg q-px-lg q-pb-none col-auto">
            <p
              v-translate
              render-html="true"
              class="q-pa-none"
            >
              By clicking on OK, FaST will retrieve the farms you have access to from %{iacsLink}
            </p>
          </q-card-section>
          <q-card-section class="q-pt-sm q-pb-none col-auto">
            <q-checkbox
              v-model="iacsConsent"
              :label="$gettextInterpolate($gettext('I allow FaST to query %{iacs_short_name} on my behalf'), {iacs_short_name: iacs.iacs_short_name })"
            />
          </q-card-section>
        </template>

        <!-- Actions -->
        <q-card-section class="q-mt-auto">
          <q-card-actions
            class="q-pa-none"
            vertical
            align="stretch"
          >
            <q-btn
              v-if="hasSuccessfulResult"
              color="primary"
              text-color="white"
              :label="$gettext('Ok')"
              @click="onClickOk"
            />
            <q-btn
              v-else
              color="primary"
              text-color="white"
              :disable="!iacsConsent"
              :label="syncError || hasEmptyResult ? $gettext('Retry') : $gettext('Next')"
              @click="onClickNext"
            />
            <q-btn
              flat
              color="primary"
              :label="$gettext('Back')"
              @click="onClickBack"
            />
          </q-card-actions>
        </q-card-section>
      </q-card>

      <div v-else>
        <p class="q-pa-md text-negative">
          <translate>
            There was an error while retrieving the data. Please try again later.
          </translate>
        </p>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import SyncFeedback from 'src/pages/holdings/components/SyncFeedback'
import RefreshIacsTokenDialog from 'src/pages/holdings/components/RefreshIacsTokenDialog'
import LoadErrorCard from 'src/pages/holdings/components/LoadErrorCard'
import queryIacs from 'src/pages/holdings/graphql/queryIacs'
import queryHoldings from 'src/pages/holdings/graphql/queryHoldings'
import queryCampaigns from 'src/pages/holdings/graphql/queryCampaigns'
import mutationSynchronizeHoldings from 'src/pages/holdings/graphql/mutationSynchronizeHoldings'
import mutationInsertIacsConsent from 'src/pages/holdings/graphql/mutationInsertIacsConsent'

const IACS_USER_UNAUTHENTICATED = 'IACS_USER_UNAUTHENTICATED'
const IACS_USER_FORBIDDEN = 'IACS_USER_FORBIDDEN'
const IACS_OBJECT_NOT_FOUND = 'IACS_OBJECT_NOT_FOUND'
const IACS_SERVICE_ERROR = 'IACS_SERVICE_ERROR'
const IACS_REMOTE_ERROR = 'IACS_REMOTE_ERROR'
const IACS_UNEXPECTED_ERROR = 'IACS_UNEXPECTED_ERROR'

const IACS_ERRORS = [IACS_USER_UNAUTHENTICATED, IACS_USER_FORBIDDEN, IACS_OBJECT_NOT_FOUND, IACS_SERVICE_ERROR, IACS_REMOTE_ERROR, IACS_UNEXPECTED_ERROR]

export default {
  name: 'HoldingSyncPage',
  mixins: [
    PlatformMixin
  ],
  components: {
    GenericLayout,
    Header,
    Footer,
    SyncFeedback,
    LoadErrorCard
  },
  data () {
    return {
      iacsConsent: false,
      syncError: null,
      loadError: null,
      syncResult: null
    }
  },
  apollo: {
    iacs: {
      query: queryIacs,
      notifyOnNetworkStatusChange: true,
      update: data => data
    },
    campaigns: {
      query: queryCampaigns,
      notifyOnNetworkStatusChange: true,
      update: data => data.campaign
    },
    holdings: {
      query: queryHoldings,
      notifyOnNetworkStatusChange: true,
      fetchPolicy: 'network-only',
      update: data => data.holding,
      result ({ error }) {
        this.loadError = error
      }
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Farms')
    },
    loading () {
      return (!this.iacs && this.$apollo.queries.iacs.loading) ||
        (!this.holdings && this.$apollo.queries.holdings.loading) ||
        (!this.campaigns && this.$apollo.queries.campaigns.loading)
    },
    username () {
      return this.$store.state.fastplatform.user.username
    },
    iacsName () {
      return this.iacs?.iacs_display_name || ''
    },
    iacsShortName () {
      return this.iacs?.iacs_short_name || ''
    },
    iacsLink () {
      if (!this.iacs?.iacs_website_url) {
        return this.iacsName
      } else {
        return `<a href="${this.iacs.iacs_website_url}" target="_blank" style="text-decoration: none;">${this.iacsName} (${this.iacsShortName})</a>`
      }
    },
    currentCampaign () {
      return this.campaigns?.find(campaign => campaign.is_current)
    },
    startCurrentCampaign () {
      return this.$route.query?.startCurrentCampaign || false
    },
    canStartCurrentCampaign () {
      return this.startCurrentCampaign &&
        this.currentCampaign &&
        this.holdings.length === 1 &&
        !this.holdings[0].holding_campaigns.length
    },
    hasObjectNotFoundError () {
      return this.syncError === IACS_OBJECT_NOT_FOUND
    },
    hasUserForbiddenError () {
      return this.syncError === IACS_USER_FORBIDDEN
    },
    hasUserUnauthenticatedError () {
      return this.syncError === IACS_USER_UNAUTHENTICATED
    },
    hasRemoteError () {
      return this.syncError === IACS_REMOTE_ERROR
    },
    hasServiceOrUnexpectedError () {
      return this.syncError === IACS_SERVICE_ERROR || this.syncError === IACS_UNEXPECTED_ERROR
    },
    hasSuccessfulResult () {
      return this.syncResult?.synchronizedHoldingCount > 0
    },
    hasEmptyResult () {
      return this.syncResult && !this.syncResult.synchronizedHoldingCount
    }
  },
  methods: {
    onClickOk () {
      this.$router.push({ name: 'holdings' })
    },
    onClickNext () {
      this.syncHoldings()
    },
    onClickBack () {
      this.$router.push({ name: 'holdings' })
    },
    async syncHoldings () {
      /* Insert user IACS consent */
      const ok = await this.processUserIacsConsent()
      if (!ok) {
        return
      }

      /* Synchronize holdings from IACS */
      this.syncError = null
      this.syncResult = null
      this.$q.loading.show({ message: this.$gettext('Loading your farms...') })

      try {
        // Synchronize holdings list
        const result = await this.$apollo.mutate({
          mutation: mutationSynchronizeHoldings
        })
        const synchronizedHoldingCount = result.data.sync_holdings.holding_ids.length

        // The holdings have synchronized on the backend, refresh our list locally
        await this.$apollo.queries.holdings.refetch()

        if (this.canStartCurrentCampaign) {
          // if current campaign can be started (at the user first login), then redirect to the holding campaign sync page
          this.$router.replace({
            name: 'holdingCampaignSync',
            params: {
              holdingId: this.holdings[0].id,
              campaignId: this.currentCampaign.id
            },
            query: {
              consentOk: true
            }
          })
        } else {
          // display result
          this.syncResult = { synchronizedHoldingCount }
        }
      } catch (e) {
        this.handleIacsErrors(e)
      } finally {
        this.$q.loading.hide()
      }
    },
    async processUserIacsConsent () {
      const mutationResponse = await this.$apollo.mutate({
        mutation: mutationInsertIacsConsent
      }).catch(e => {
        console.error('Could not insert user IACS consent', e)
        this.syncError = IACS_UNEXPECTED_ERROR
      })
      return mutationResponse?.data?.insertedUserIacsConsent?.id
    },
    handleIacsErrors (error) {
      try {
        const errorMessage = error.message ?? IACS_UNEXPECTED_ERROR
        this.syncError = IACS_ERRORS.includes(errorMessage) ? errorMessage : IACS_UNEXPECTED_ERROR
        if (errorMessage === IACS_USER_UNAUTHENTICATED) {
          // User session expired: prompt the user to login again
          const iacsUnauthenticatedParams = error.graphQLErrors.find(e => e.message === IACS_USER_UNAUTHENTICATED).extensions
          const refreshUrl = iacsUnauthenticatedParams?.login_url
          if (refreshUrl) {
            this.$q.dialog({
              component: RefreshIacsTokenDialog,
              componentProps: {
                iacsName: this.iacsName,
                iacsShortName: this.iacsShortName,
                iacsRefreshTokenUrl: refreshUrl
              }
            }).onOk(() => {
              this.syncHoldings()
            })
          } else {
            console.error('Could not sync holdings and could not refresh IACS token because the refresh URL is not provided')
            this.syncError = IACS_UNEXPECTED_ERROR
          }
        }
      } catch (e) {
        console.error('Could not sync holdings: unexpected error', error)
        this.syncError = IACS_UNEXPECTED_ERROR
      }
    },
    onDataLoadRetry () {
      Promise.all([
        this.$apollo.queries.iacs.refetch(),
        this.$apollo.queries.campaigns.refetch(),
        this.$apollo.queries.holdings.refetch()
      ])
    }
  }
}
</script>
